"{ Package: 'cvut:fel/cface' }"

"{ NameSpace: Cface }"

CTypeNode subclass:#CArrayNode
	instanceVariableNames:'type size'
	classVariableNames:''
	poolDictionaries:''
	category:'Cface-C AST'
!

!CArrayNode class methodsFor:'documentation'!

history

    "Created: / 25-10-2007 / 16:50:37 / haja"
    "Created: #id / 25-10-2007 / 16:50:42 / haja"
    "Created: #id: / 25-10-2007 / 16:50:42 / haja"
    "Created: #size / 25-10-2007 / 16:50:42 / haja"
    "Created: #size: / 25-10-2007 / 16:50:42 / haja"
    "Created: #id:size: / 25-10-2007 / 16:53:04 / haja"
    "Deleted: #acceptVisitor: / 02-11-2007 / 10:39:35 / haja"
    "Created: #acceptVisitor: / 02-11-2007 / 10:39:47 / haja"
    "Created: #buildTypeCheckFor:on: / 19-12-2007 / 15:55:50 / haja"
    "Created: #buildObjectCreationOn: / 19-12-2007 / 16:40:09 / haja"
    "Created: #buildValueExtractionFor:on: / 19-12-2007 / 17:30:51 / haja"
    "Created: #buildObjectCreationFor:on: / 19-12-2007 / 17:39:17 / haja"
    "Deleted: #buildObjectCreationOn: / 19-12-2007 / 17:39:20 / haja"
    "Created: #buildTypeDescriptionOn: / 20-12-2007 / 12:13:36 / haja"
! !

!CArrayNode methodsFor:'accessing'!

cByteSize

    "
        Cface::CArrayNode new cByteSize       
    "

    %{
        return __MKSMALLINT(sizeof(void*));
    %}.
    ^4

    "Created: / 09-07-2008 / 19:30:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

size
    ^ size

    "Created: / 04-07-2008 / 12:25:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

size:something
    size := something.

    "Created: / 04-07-2008 / 12:25:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

type
    ^ type

    "Created: / 10-02-2008 / 19:19:51 / janfrog"
!

type:something
    type := something.

    "Created: / 10-02-2008 / 19:19:51 / janfrog"
! !

!CArrayNode methodsFor:'testing'!

isCArrayNode
    ^ true

    "Created: / 17-02-2008 / 21:51:50 / janfrog"
! !

!CArrayNode methodsFor:'visiting'!

acceptVisitor:aVisitor 
    "Double dispatch back to the visitor, passing my type encoded in
     the selector (visitor pattern)"
    "stub code automatically generated - please change if required"
    
    ^ aVisitor visitCArrayNode:self

    "Created: / 02-11-2007 / 10:39:47 / haja"
    "Modified: / 10-02-2008 / 10:44:35 / janfrog"
! !

!CArrayNode class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/cvut-fel/cface/Cface__CArrayNode.st,v 1.1 2008/02/26 15:59:33 vranyj1 Exp $'
! !
